/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 7/21/2006; 7:55:49 PM

#include "All.h"

/*
	Draws a string (in 'F_16x20', with a white bordure, and centered !)
*/
void drawSexyString(const char* str, char *dest) {
	char mini_buffer[10];
	unsigned short large_buffer[20];
	short string_offset_x = (240-((strlen(str)-1)<<4))>>1;

	signed char x[8] = {1,1,0,-1,-1,-1,0,1};
	signed char y[8] = {0,1,1,1,0,-1,-1,-1};
	short j=0,i=0;
	FontSetSys(F_8x10);
	while (str[j] != '\0') {
		
		memset(mini_buffer,0,10);
		PortSet(mini_buffer,7,9);
		DrawChar (0,0, str[j], A_REVERSE);	
		DoubleSpriteDimensionsX8_R(10,mini_buffer,1,large_buffer);
		
		for (i=8;i--;) {
			Sprite16_AND(string_offset_x+(j<<4)+x[i],50+y[i],20,large_buffer,dest);
		}
		
		memset(mini_buffer,0,10);
		PortSet(mini_buffer,7,9);
		DrawChar (0,0, str[j], A_NORMAL);
		DoubleSpriteDimensionsX8_R(10,mini_buffer,1,large_buffer);
		Sprite16_OR(string_offset_x+(j<<4),50,20,large_buffer,dest);
		j++;
	}
	PortRestore();
}