/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 4/13/2006; 8:29:06 PM

#include "All.h"


/*

*/
char getWaypoint(short x, short y) {
	return (allocatedMem->waypointArray[y][x]);
}


/*

*/
void addWaypoint(short v, long x, long y) {
	x>>=9;
	y>>=9;
	allocatedMem->waypointArray[x][y] = v;//D'oh!		
}


/*

*/
void addWaypoints(short v, long x1, long y1, long x2, long y2) {
	x1<<=9;
	y1<<=9; 
	x2<<=9;
	y2<<=9;
	long dx = (x2-x1)>>5;
	long dy = (y2-y1)>>5;
	short i;
	for (i=32;i--;) {
		addWaypoint(v,x1,y1);			
		x1+=dx;
		y1+=dy;
	}
}

/*

*/
void checkWaypoint(Player *p) {
	short n=getWaypoint((p->x>>6)/12,   (p->y>>6)/12);
	if (n==p->nextWaypoint) {
		n++;
		if (n>p->numberOfWaypoints)
		n=0;
		p->nextWaypoint = n;
		if (n==2) {
			if (allocatedMem->saveFile!=NULL)
			allocatedMem->saveFile->scores[ p->mapNumber ].laps++;
			
			if (p->raceMode == THREE_LAPS) {
				p->numberOfLapDone++;
				if (p->numberOfLapDone == 3)
				p->hasFinishedRacing = TRUE;
			}
			else
			{
				if (p->currentFPL<p->bestFPL)
				p->bestFPL=p->currentFPL;
				p->currentFPL = 0;
				if (allocatedMem->saveFile!=NULL)
				allocatedMem->saveFile->scores[ p->mapNumber ].bestLap = p->bestFPL;
			}
		}
	}
}

/*
	draws a line representing the next waypoint

void drawWaypoint(short x, short y, short angle, short x1, short y1, short x2, short y2, char *dest) {
	


	long dx1=(x-x1)>>6;
	long dy1=(y-y1)>>6;
	short xx1=-(dx1*cosTable_512[angle]-dy1*sinTable_512[angle])/512;
	short yy1=-(dx1*sinTable_512[angle]+dy1*cosTable_512[angle])/512;
	
	long dx2=(x-x2)>>6;
	long dy2=(y-y2)>>6;
	short xx2=-(dx2*cosTable_512[angle]-dy2*sinTable_512[angle])/512;
	short yy2=-(dx2*sinTable_512[angle]+dy2*cosTable_512[angle])/512;
	short unused=unused;
	ClrScr();
	//ClipDrawLine_R(0,0,20,20,unused,A_NORMAL,dest,FastDrawLine_R);
	
	ClipDrawLine_R(70,70,40,40,&unused,A_NORMAL,LCD_MEM,FastDrawLine_R);
	
	ClipDrawLine_R(0,0,20,20,&unused,A_NORMAL,LCD_MEM,FastDrawLine_R);
	
	
//	printf("booooboooo\nbooodhsofhsdf");
	//void (__attribute__((__stkparm__)) *)(void* plane asm("%a0"),short x1 asm("%d0"),short y1 asm("%d1"),short x2 asm("%d2"),short y2 asm("%d3"),short mode)) __attribute__((__stkparm__));
//(void* plane asm("%a0"),short x1 asm("%d0"),short y1 asm("%d1"),short x2 asm("%d2"),short y2 asm("%d3"),short mode) __attribute__((__stkparm__));

	EXT_SETPIX(p,x,y)
			ClipFastOutlinedCircle_DRAW_R(dest,(240-16)/2+xx+8,(128-16)/2 + 48+yy +8,e->radius);
			ClipFastOutlinedCircle_DRAW_R(dest,(240-16)/2+xx+8,(128-16)/2 + 48+yy +8,e->radius-4);
			e->radius+=e->dRadius;
			if (e->radius > e->maxRadius) {
				e->on = FALSE;
			}
		}
	}
}
*/